let calc = {};


calc.basic = (s) => {
    for (let y in s) {
        for (let x in s[y]) { //遍历每一个
            if (s[y][x].length == 1) {
                for (let xx in s[y]) { //去除行列不可能
                    if (xx != x) {
                        if (remove(s, s[y][xx], s[y][x][0], '去除横向不可能')) {
                            // RRecord(s, '去除横向不可能', true);
                        }
                    }
                }
                for (let yy in s) {
                    if (yy != y) {
                        if (remove(s, s[yy][x], s[y][x][0], '去除竖项不可能')) {
                            // RRecord(s, '去除竖项不可能', true);
                        }
                    }
                }
                let startxx = parseInt(x / 3) * 3;
                let startyy = parseInt(y / 3) * 3;
                for (let xx = startxx; xx < startxx + 3; xx++) {
                    for (let yy = startyy; yy < startyy + 3; yy++) {
                        if (xx != x || yy != y) {
                            if (remove(s, s[yy][xx], s[y][x][0], '去除九宫格不可能')) {
                                // RRecord(s, '去除九宫格不可能', true);
                            }
                        }
                    }
                }
            }
        }
    }
}


calc.dl_heng = (s) => {
    //横向独立
    for (let y in s) {
        for (let i of [1, 2, 3, 4, 5, 6, 7, 8, 9]) {
            let find = [];
            for (let x in s) {
                if (s[y][x].indexOf(i) >= 0) {
                    find.push({
                        y: y,
                        x: x
                    })
                }
            }
            if (find.length == 1 && s[find[0].y][find[0].x].length > 1) {
                s[find[0].y][find[0].x] = [i];
                RRecord(s, '横向中解中此解独立', true);
            }
        }
    }
}

calc.dl_shu = (s) => {
    //竖向独立
    for (let x in s) {
        for (let i of [1, 2, 3, 4, 5, 6, 7, 8, 9]) {
            let find = [];
            for (let y in s) {
                if (s[y][x].indexOf(i) >= 0) {
                    find.push({
                        y: y,
                        x: x
                    })
                }
            }
            if (find.length == 1 && s[find[0].y][find[0].x].length > 1) {
                s[find[0].y][find[0].x] = [i];
                RRecord(s, '竖向中解中此解独立', true);
            }
        }
    }
}

calc.dl_jiu = (s) => {
    //九宫格独立
    for (let dy of [0, 3, 6]) {
        for (let dx of [0, 3, 6]) {
            for (let i of [1, 2, 3, 4, 5, 6, 7, 8, 9]) {
                let find = [];
                for (let y = dy; y < dy + 3; y++) {
                    for (let x = dx; x < dx + 3; x++) {
                        if (s[y][x].indexOf(i) >= 0) {
                            find.push({
                                y: y,
                                x: x
                            })
                        }
                    }
                }
                if (find.length == 1 && s[find[0].y][find[0].x].length > 1) {
                    s[find[0].y][find[0].x] = [i];
                    RRecord(s, '九宫格中解中此解独立', true);
                }
            }
        }
    }
}

calc.jiu_biran_heng = (s) => {
    for (let dy of [0, 3, 6]) {
        for (let dx of [0, 3, 6]) {

            for (let y = dy; y < dy + 3; y++) {
                //找出小一行可能解
                let ables = concat(s[y][dx], s[y][dx + 1], s[y][dx + 2]);
                //减去小一行之外可能解                
                for (let yy = dy; yy < dy + 3; yy++) {
                    for (let xx = dx; xx < dx + 3; xx++) {
                        if (yy != y) {
                            remove(s, ables, s[yy][xx], false);
                        }
                    }
                }
                //这一整行除了这三格,都不可能出现ables
                if (ables.length > 0) {
                    for (let x in s) {
                        if (x < dx || x >= dx + 3) {
                            if (remove(s, s[y][x], ables, `九宫格(${y}行${dx}列)横向3个(${ables.join(',')}),不可能在九宫格外`)) {
                                // RRecord(s, '九宫格横向3个,不可能在九宫格外', true);
                            }
                        }
                    }
                }
            }
        }
    }
}


calc.jiu_biran_shu = (s) => {
    for (let dy of [0, 3, 6]) {
        for (let dx of [0, 3, 6]) {

            for (let x = dx; x < dx + 3; x++) {
                //找出小一列可能解
                let ables = concat(s[dy][x], s[dy + 1][x], s[dy + 1][x]);
                //减去小一列之外可能解
                for (let yy = dy; yy < dy + 3; yy++) {
                    for (let xx = dx; xx < dx + 3; xx++) {
                        if (xx != x) {
                            remove(s, ables, s[yy][xx], false);
                        }
                    }
                }
                //这一整行除了这三格,都不可能出现ables
                if (ables.length > 0) {
                    for (let y in s) {
                        if (y < dy || y >= dy + 3) {
                            if (remove(s, s[y][x], ables, `九宫格(${dy}行${x}列)竖向3个(${ables.join(',')}),不可能在九宫格外`)) {
                                // RRecord(s, '九宫格竖向3个,不可能在九宫格外', true);
                            }
                        }
                    }
                }
            }
        }
    }
}

calc.xiangtong_heng = (s) => {
    for_0_8((y) => {
        for_0_8((xx) => {
            if (s[y][xx].length == 1) {
                return
            }
            let find_same_x = [];
            // for (let xxx = xx + 1; xxx <= 8; xxx++) {
            for (let xxx = 0; xxx <= 8; xxx++) {
                if (baohan(s[y][xx], s[y][xxx])) {
                    find_same_x.push(xxx)
                }
            }
            // if (find_same_x.length == s[y][xx].length) {
            if (find_same_x.length >= 2 && find_same_x.length == s[y][xx].length) {
                for_0_8((x) => {
                    // console.log(find_same_x, x);
                    if (find_same_x.indexOf(x) == -1) {
                        remove(s, s[y][x], s[y][xx], `(${s[y][xx].join(',')}),在同一横行存在${find_same_x.length}遍,去除其他行这${s[y][xx].length}个值`)
                    }
                })
            }
        })
    })
}

calc.xiangtong_shu = s => {
    let ts = t_s(s);
    t_s_on = true;
    calc.xiangtong_heng(ts);
    t_s_on = false
    for_0_8(y => {
        for_0_8(x => {
            s[y][x] = ts[x][y];
        })
    })
}



// calc.xiangtong_shu = (s) => {
//     for_0_8((x) => {
//         for_0_8((yy) => {
//             if (s[yy][x].length == 1) {
//                 return
//             }
//             let find_same_x = [];
//             find_same_x.push(yy)
//             for (let yyy = yy + 1; yyy <= 8; yyy++) {
//                 if (dengyu(s[yy][x], s[yyy][x])) {
//                     find_same_x.push(yyy)
//                 }
//             }
//             if (find_same_x.length == s[yy][x].length) {
//                 for_0_8((y) => {
//                     // console.log(find_same_x, x);
//                     if (find_same_x.indexOf(y) == -1) {
//                         remove(s, s[y][x], s[yy][x], `(${s[yy][x].join(',')}),在同一竖列存在${find_same_x.length}遍,去除其他行这${s[yy][x].length}个值`)
//                     }
//                 })
//             }
//         })
//     })
// }


calc.xiangtong_jiu = s => {
    for (let dy of [0, 3, 6]) {
        for (let dx of [0, 3, 6]) { //一个宫内
            for (let y = dy; y < dy + 3; y++) {
                for (let x = dx; x < dx + 3; x++) { //遍历第一个数字
                    if (s[y][x].length == 1) {
                        continue
                    }
                    let find_same = [];
                    for (let yy = y; yy < dy + 3; yy++) {
                        for (let xx = x; xx < dx + 3; xx++) { //遍历第二个数字
                            // console.log(yy,xx,s[yy][xx], s[y][x])
                            if (dengyu(s[yy][xx], s[y][x])) {
                                find_same.push({
                                    y: yy,
                                    x: xx
                                })
                            }
                        }
                    }

                    if (find_same.length == s[y][x].length) {
                        // console.log(find_same[0], find_same[1])

                        for (let yyy = dy; yyy < dy + 3; yyy++) {
                            for (let xxx = dx; xxx < dx + 3; xxx++) { //消除数字
                                let is_same = false;
                                for (let pd of find_same) {
                                    if (pd.y == yyy && pd.x == xxx) {
                                        is_same = true;
                                    }
                                }
                                if (!is_same) {
                                    remove(s, s[yyy][xxx], s[y][x], `(${s[y][x].join(',')}),在同九宫格存在${find_same.length}遍,去除其他这${s[y][x].length}个值`)
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

calc.x_wing_xia = (s) => {
    for_0_8(y => {
        for (let i of [1, 2, 3, 4, 5, 6, 7, 8, 9]) {
            let find_x = [];
            for_0_8(x => { //第一行数字 y,find_x[0]   y,find_x[1]
                // console.log(y,x,s)
                if (s[y][x].indexOf(i) >= 0) {
                    find_x.push(x)
                }
            })
            if (find_x.length == 2) { //往下找
                for (let yy = y + 1; yy <= 8; yy++) {
                    let ffind_x = [];
                    for_0_8(xx => { //下个行数字 yy,find_x[0]   y,find_x[1]
                        if (s[yy][xx].indexOf(i) >= 0) {
                            ffind_x.push(xx)
                        }
                    })
                    // console.log(find_x,ffind_x)
                    if (ffind_x.length == 2 && ffind_x[0] == find_x[0] && ffind_x[1] == find_x[1]) { //找到x-wing,消除之间
                        let tip = `x-wing:${y}行,${yy}行,${find_x[0]}列,${find_x[1]}列,横向唯一两个${i}构成x-wing`;
                        // for (let yyy = y + 1; yyy < yy; yyy++) {
                        for_0_8(yyy => {
                            if (yyy != y && yyy != yy) {
                                remove(s, s[yyy][find_x[0]], i, tip);
                                remove(s, s[yyy][find_x[1]], i, tip);
                            }
                        })
                        // }
                        // for (let xxx = find[0] + 1; xxx < find[1]; xxx++) {
                        for_0_8(xxx => {
                            if (xxx != find_x[0] && xxx != find_x[1]) {
                                remove(s, s[y][xxx], i, tip);
                                remove(s, s[yy][xxx], i, tip);
                            }
                        })
                        // }
                    }
                }
            }
        }
    })
}

calc.x_wing_you = s => {
    let ts = t_s(s);
    t_s_on = true;
    calc.x_wing_xia(ts);
    t_s_on = false
    for_0_8(y => {
        for_0_8(x => {
            s[y][x] = ts[x][y];
        })
    })
}


calc.dl2_heng = s => {
    for_0_8(y => {
        for_0_8(x => {
            if (s[y][x].length >= 2) {
                for (let i_a = 0; i_a <= s[y][x].length - 2; i_a++) {
                    for (let i_b = i_a + 1; i_b <= s[y][x].length - 1; i_b++) { //双层数字
                        let num_a = s[y][x][i_a];
                        let num_b = s[y][x][i_b];
                        let find_x = [];
                        for (let xx = 0; xx <= 8; xx++) {
                            if (s[y][xx].indexOf(num_a) >= 0 || s[y][xx].indexOf(num_b) >= 0) {
                                find_x.push(xx);
                            }
                        }
                        if (find_x.length == 2) {
                            let text = `横向存在2次独立(${num_a} ${num_b}),消除这两格其余可能性`;
                            if (!dengyu(s[y][find_x[0]], [num_a, num_b])) {
                                s[y][find_x[0]] = [num_a, num_b]
                                RRecord(s, text, true);
                            }
                            if (!dengyu(s[y][find_x[1]], [num_a, num_b])) {
                                s[y][find_x[1]] = [num_a, num_b]
                                RRecord(s, text, true);
                            }
                        }
                    }
                }
            }
        })
    })
}

calc.dl2_shu = s => {
    let ts = t_s(s);
    t_s_on = true;
    calc.dl2_heng(ts);
    t_s_on = false
    for_0_8(y => {
        for_0_8(x => {
            s[y][x] = ts[x][y];
        })
    })
}

calc.paichu_jiu_from_hang = s => {
    //横向独立
    for_0_8(y => {
        for (let i of [1, 2, 3, 4, 5, 6, 7, 8, 9]) {
            let find_x = [];
            for_0_8(x => {
                if (s[y][x].indexOf(i) >= 0) {
                    find_x.push(x);
                }
            })
            if (find_x.length >= 2 && find_x.length <= 3) {
                let jiu_x_a = parseInt(find_x[0] / 3) * 3;
                let jiu_y_a = parseInt(y / 3) * 3;
                let inrange = true;
                // console.log(y,i,find_x)
                for (let xx of find_x) {
                    if (xx < jiu_x_a || xx > jiu_x_a + 2) {
                        inrange = false;
                    }
                }
                if (inrange) {
                    for (let yy = jiu_y_a; yy <= jiu_y_a + 2; yy++) {
                        for (let xx = jiu_x_a; xx <= jiu_x_a + 2; xx++) {
                            // console.log(yy,xx)

                            if (yy != y) {
                                // console.log(y, jiu_y_a, jiu_x_a, yy, xx, find_x)
                                remove(s, s[yy][xx], i, `第${y}行,第${find_x[0]}列的数字${i}只存在这一行中,九宫格中不会有此解`)
                            }
                        }
                    }
                    // console.log('over')
                }
            }
        }
    })
}

calc.paichu_jiu_from_shu = s => {
    let ts = t_s(s);
    t_s_on = true;
    calc.paichu_jiu_from_hang(ts);
    t_s_on = false
    for_0_8(y => {
        for_0_8(x => {
            s[y][x] = ts[x][y];
        })
    })
}








































let easyRun = (s) => {
    _find_new = false;
    //遍历每一个,符合基本要求

    calc.basic(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.dl_heng(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.dl_shu(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.dl_jiu(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.xiangtong_heng(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.xiangtong_shu(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.xiangtong_jiu(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.jiu_biran_heng(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.jiu_biran_shu(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.paichu_jiu_from_hang(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.paichu_jiu_from_shu(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.x_wing_xia(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.x_wing_you(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.dl2_heng(s)
    if (_find_new) {
        easyRun(s);
    }

    calc.dl2_shu(s)
    if (_find_new) {
        easyRun(s);
    }


}





let runCheck = (s) => {
    if (s === false) {
        return true;
    }
    let res; //null继续,false错误,true成功
    let max = 0;
    let min = 9;
    for (let y in s) {
        for (let x in s[y]) {
            let len = s[y][x].length;
            if (len > max) {
                max = len;
            }
            if (len < min) {
                min = len;
            }
        }
    }
    // console.log(min, max)
    if (min == 0) {
        return false;
    }
    if (max == 1) {
        return true;
    }
    return null;
}

let text;
let fx_y = 0;
let fx_x = 0;
let fx_i = -1;
let next = () => {
    fx_i++;
    if (s[fx_y][fx_x].length <= 1 || s[fx_y][fx_x][fx_i] === undefined) {
        fx_i = -1;
        if (fx_x >= 8) {
            fx_x = 0;
            fx_y++;
        }
        if (fx_y <= 8) {
            fx_x++;
        } else {
            return false;
        }
        next();
    }
    _find_new = false;
    _once_find_new = false;
    startTime = new Date().getTime();
    ssRecord = [];
    return true;
}

let fenxi = (s) => {
    if (!next()) {
        return false;
    }
    let setVal = s[fx_y][fx_x][fx_i];
    console.log(`第${fx_y}行第${fx_x}列,假设用第(${fx_i+1}/${s[fx_y][fx_x].length})个:${setVal},尝试: `);
    let testSS = $.extend(true, [], s);
    testSS[fx_y][fx_x] = [setVal]
    easyRun(testSS);
    return testSS;
}


let run = (s) => {
    for (let y in s) {
        for (let x in s[y]) {
            if (typeof s[y][x] == 'number') { //未知项
                if (s[y][x] > 0) {
                    s[y][x] = [s[y][x]]
                } else {
                    s[y][x] = [1, 2, 3, 4, 5, 6, 7, 8, 9]
                }
            }
        }
    }
    do {
        _once_find_new = false;
        calc.basic(s)
    } while (_once_find_new)

    ssRecord_start = true;
    if (ssRecord.length == 0) {
        ssRecord.push({
            ss: $.extend(true, [], s),
            tip: '原始数据'
        })
    }


    easyRun(s);



    let check = runCheck(s);
    if (check === true) {
        console.log('成功了!!!!');
        return s;
    } else if (check === false) {
        console.log('出错了****');
        return s;
    } else if (!_find_new) {
        console.log('算不下去了....');
    }
    return s;
    // fenxi(s);
}



let jiashe = (s) => {
    let testSS = fenxi(s);
    load(testSS);
    let testCheck = runCheck(testSS);

    if (testCheck === null) {
        console.log('还有未确定,继续')
        // fenxi(easyRes, true)
    } else if (testCheck === true) {
        console.log('算出来了')
        // return easyRes;
    } else if (testCheck === false) {
        console.log('不成立');
    }

    return testCheck;
}

let for_jiashe = (s) => {
    let testCheck = false;
    let testSS;
    while (testCheck !== true) {
        testSS = fenxi(s);
        testCheck = runCheck(testSS);
    }
    if (testSS === false) {
        console.log('无能为力...')
    } else {
        load(testSS);
    }
}